Booster = {}

local gfx <const> = playdate.graphics

local function newBooster(x, y)
    return setmetatable({
        position = { x = x, y = y },
        size = { x = 40, y = 10 },
    }, { __index = Booster })
end

function Booster:elasticity(velocity)
    velocity.y = (math.abs(velocity.y) + 190) * -0.5
    velocity.x = velocity.x + 50
end

function Booster:draw()
    gfx.fillRect(self.position.x, self.position.y, self.size.x, self.size.y)
end

local boosterIndex = 1
local boosterCache = {}
for i = 1, 200 do
    boosterCache[i] = newBooster(-999, 999)
end

function Booster.cacheSize()
    return #boosterCache
end

-- Boosters should be "initialized" almost always increasing in X value
function Booster.get(x, y)
    local booster = boosterCache[boosterIndex]
    booster.position.x = x
    booster.position.y = y

    boosterIndex = boosterIndex + 1
    if boosterIndex > #boosterCache then
        boosterIndex = 1
    end

    return booster
end

-- Assumes that at least one Booster has already been created.
function Booster.newestBooster()
    return boosterCache[boosterIndex]
end
