collisionDetection = tiny.filteredSystem(
    { position = T.XyPair, size = T.XyPair, elasticity = T.Elasticity, isSolid = Maybe(T.bool) },
    -- Here, the entity, e, refers to some entity that the burger global(!) may be colliding with.
    function(e)
        if not burger.velocity then
            return
        end
        local burgerTop = burger.position.y
        local burgerBottom = burger.position.y + burger.size.y
        local entityTop = e.position.y
        local entityBottom = entityTop + e.size.y

        local withinY = (entityTop > burgerTop and entityTop < burgerBottom)
            or (entityBottom > burgerTop and entityBottom < burgerBottom)

        if not withinY then
            return
        end

        if burger.position.x < e.position.x + e.size.x and burger.position.x + burger.size.x > e.position.x then
            if e.isSolid then
                -- Assumes impact from the top
                burger.position.y = entityTop - burger.size.y
            end
            e:elasticity(burger.velocity)
        end
    end
)
